import { z } from 'zod';
export declare const SmokerConfigSchema: z.ZodObject<{
    add: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodArray<z.ZodString, "many">]>>;
    all: z.ZodOptional<z.ZodBoolean>;
    bail: z.ZodOptional<z.ZodBoolean>;
    includeRoot: z.ZodOptional<z.ZodBoolean>;
    json: z.ZodOptional<z.ZodBoolean>;
    linger: z.ZodOptional<z.ZodBoolean>;
    verbose: z.ZodOptional<z.ZodBoolean>;
    workspace: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodArray<z.ZodString, "many">]>>;
    pm: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodArray<z.ZodString, "many">]>>;
    script: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodArray<z.ZodString, "many">]>>;
    scripts: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodArray<z.ZodString, "many">]>>;
    loose: z.ZodOptional<z.ZodBoolean>;
    checks: z.ZodOptional<z.ZodBoolean>;
    rules: z.ZodOptional<z.ZodEffects<z.ZodObject<{
        "no-banned-files": z.ZodOptional<z.ZodUnion<[z.ZodDefault<z.ZodEnum<["off", "warn", "error"]>>, z.ZodObject<{
            allow: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            deny: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, "strip", z.ZodTypeAny, {
            allow?: string[] | undefined;
            deny?: string[] | undefined;
        }, {
            allow?: string[] | undefined;
            deny?: string[] | undefined;
        }>, z.ZodTuple<[z.ZodObject<{
            allow: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            deny: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, "strip", z.ZodTypeAny, {
            allow?: string[] | undefined;
            deny?: string[] | undefined;
        }, {
            allow?: string[] | undefined;
            deny?: string[] | undefined;
        }>], null>, z.ZodTuple<[z.ZodObject<{
            allow: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            deny: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, "strip", z.ZodTypeAny, {
            allow?: string[] | undefined;
            deny?: string[] | undefined;
        }, {
            allow?: string[] | undefined;
            deny?: string[] | undefined;
        }>, z.ZodDefault<z.ZodEnum<["off", "warn", "error"]>>], null>]>>;
        "no-missing-pkg-files": z.ZodOptional<z.ZodUnion<[z.ZodDefault<z.ZodEnum<["off", "warn", "error"]>>, z.ZodObject<{
            bin: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
            fields: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, "strip", z.ZodTypeAny, {
            bin?: boolean | undefined;
            fields?: string[] | undefined;
        }, {
            bin?: boolean | undefined;
            fields?: string[] | undefined;
        }>, z.ZodTuple<[z.ZodObject<{
            bin: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
            fields: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, "strip", z.ZodTypeAny, {
            bin?: boolean | undefined;
            fields?: string[] | undefined;
        }, {
            bin?: boolean | undefined;
            fields?: string[] | undefined;
        }>], null>, z.ZodTuple<[z.ZodObject<{
            bin: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
            fields: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, "strip", z.ZodTypeAny, {
            bin?: boolean | undefined;
            fields?: string[] | undefined;
        }, {
            bin?: boolean | undefined;
            fields?: string[] | undefined;
        }>, z.ZodDefault<z.ZodEnum<["off", "warn", "error"]>>], null>]>>;
        "no-missing-entry-point": z.ZodOptional<z.ZodUnion<[z.ZodDefault<z.ZodEnum<["off", "warn", "error"]>>, z.ZodUndefined, z.ZodTuple<[z.ZodUndefined], null>, z.ZodTuple<[z.ZodUndefined, z.ZodDefault<z.ZodEnum<["off", "warn", "error"]>>], null>]>>;
        "no-missing-exports": z.ZodOptional<z.ZodUnion<[z.ZodDefault<z.ZodEnum<["off", "warn", "error"]>>, z.ZodObject<{
            types: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
            require: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
            import: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
            order: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
            glob: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        }, "strip", z.ZodTypeAny, {
            types?: boolean | undefined;
            require?: boolean | undefined;
            import?: boolean | undefined;
            order?: boolean | undefined;
            glob?: boolean | undefined;
        }, {
            types?: boolean | undefined;
            require?: boolean | undefined;
            import?: boolean | undefined;
            order?: boolean | undefined;
            glob?: boolean | undefined;
        }>, z.ZodTuple<[z.ZodObject<{
            types: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
            require: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
            import: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
            order: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
            glob: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        }, "strip", z.ZodTypeAny, {
            types?: boolean | undefined;
            require?: boolean | undefined;
            import?: boolean | undefined;
            order?: boolean | undefined;
            glob?: boolean | undefined;
        }, {
            types?: boolean | undefined;
            require?: boolean | undefined;
            import?: boolean | undefined;
            order?: boolean | undefined;
            glob?: boolean | undefined;
        }>], null>, z.ZodTuple<[z.ZodObject<{
            types: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
            require: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
            import: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
            order: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
            glob: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        }, "strip", z.ZodTypeAny, {
            types?: boolean | undefined;
            require?: boolean | undefined;
            import?: boolean | undefined;
            order?: boolean | undefined;
            glob?: boolean | undefined;
        }, {
            types?: boolean | undefined;
            require?: boolean | undefined;
            import?: boolean | undefined;
            order?: boolean | undefined;
            glob?: boolean | undefined;
        }>, z.ZodDefault<z.ZodEnum<["off", "warn", "error"]>>], null>]>>;
    }, "strip", z.ZodTypeAny, {
        "no-banned-files"?: "error" | {
            allow?: string[] | undefined;
            deny?: string[] | undefined;
        } | "warn" | "off" | [{
            allow?: string[] | undefined;
            deny?: string[] | undefined;
        }] | [{
            allow?: string[] | undefined;
            deny?: string[] | undefined;
        }, "error" | "warn" | "off"] | undefined;
        "no-missing-pkg-files"?: "error" | "warn" | "off" | {
            bin?: boolean | undefined;
            fields?: string[] | undefined;
        } | [{
            bin?: boolean | undefined;
            fields?: string[] | undefined;
        }] | [{
            bin?: boolean | undefined;
            fields?: string[] | undefined;
        }, "error" | "warn" | "off"] | undefined;
        "no-missing-entry-point"?: "error" | [undefined] | "warn" | "off" | [undefined, "error" | "warn" | "off"] | undefined;
        "no-missing-exports"?: "error" | "warn" | "off" | {
            types?: boolean | undefined;
            require?: boolean | undefined;
            import?: boolean | undefined;
            order?: boolean | undefined;
            glob?: boolean | undefined;
        } | [{
            types?: boolean | undefined;
            require?: boolean | undefined;
            import?: boolean | undefined;
            order?: boolean | undefined;
            glob?: boolean | undefined;
        }] | [{
            types?: boolean | undefined;
            require?: boolean | undefined;
            import?: boolean | undefined;
            order?: boolean | undefined;
            glob?: boolean | undefined;
        }, "error" | "warn" | "off"] | undefined;
    }, {
        "no-banned-files"?: "error" | {
            allow?: string[] | undefined;
            deny?: string[] | undefined;
        } | "warn" | "off" | [{
            allow?: string[] | undefined;
            deny?: string[] | undefined;
        }] | [{
            allow?: string[] | undefined;
            deny?: string[] | undefined;
        }, "error" | "warn" | "off" | undefined] | undefined;
        "no-missing-pkg-files"?: "error" | "warn" | "off" | {
            bin?: boolean | undefined;
            fields?: string[] | undefined;
        } | [{
            bin?: boolean | undefined;
            fields?: string[] | undefined;
        }] | [{
            bin?: boolean | undefined;
            fields?: string[] | undefined;
        }, "error" | "warn" | "off" | undefined] | undefined;
        "no-missing-entry-point"?: "error" | [undefined] | "warn" | "off" | [undefined, "error" | "warn" | "off" | undefined] | undefined;
        "no-missing-exports"?: "error" | "warn" | "off" | {
            types?: boolean | undefined;
            require?: boolean | undefined;
            import?: boolean | undefined;
            order?: boolean | undefined;
            glob?: boolean | undefined;
        } | [{
            types?: boolean | undefined;
            require?: boolean | undefined;
            import?: boolean | undefined;
            order?: boolean | undefined;
            glob?: boolean | undefined;
        }] | [{
            types?: boolean | undefined;
            require?: boolean | undefined;
            import?: boolean | undefined;
            order?: boolean | undefined;
            glob?: boolean | undefined;
        }, "error" | "warn" | "off" | undefined] | undefined;
    }>, {
        getEnabledRules: () => Set<"no-banned-files" | "no-missing-entry-point" | "no-missing-exports" | "no-missing-pkg-files">;
        isRuleEnabled: (ruleName: string) => boolean;
        "no-banned-files"?: "error" | {
            allow?: string[] | undefined;
            deny?: string[] | undefined;
        } | "warn" | "off" | [{
            allow?: string[] | undefined;
            deny?: string[] | undefined;
        }] | [{
            allow?: string[] | undefined;
            deny?: string[] | undefined;
        }, "error" | "warn" | "off"] | undefined;
        "no-missing-pkg-files"?: "error" | "warn" | "off" | {
            bin?: boolean | undefined;
            fields?: string[] | undefined;
        } | [{
            bin?: boolean | undefined;
            fields?: string[] | undefined;
        }] | [{
            bin?: boolean | undefined;
            fields?: string[] | undefined;
        }, "error" | "warn" | "off"] | undefined;
        "no-missing-entry-point"?: "error" | [undefined] | "warn" | "off" | [undefined, "error" | "warn" | "off"] | undefined;
        "no-missing-exports"?: "error" | "warn" | "off" | {
            types?: boolean | undefined;
            require?: boolean | undefined;
            import?: boolean | undefined;
            order?: boolean | undefined;
            glob?: boolean | undefined;
        } | [{
            types?: boolean | undefined;
            require?: boolean | undefined;
            import?: boolean | undefined;
            order?: boolean | undefined;
            glob?: boolean | undefined;
        }] | [{
            types?: boolean | undefined;
            require?: boolean | undefined;
            import?: boolean | undefined;
            order?: boolean | undefined;
            glob?: boolean | undefined;
        }, "error" | "warn" | "off"] | undefined;
    }, {
        "no-banned-files"?: "error" | {
            allow?: string[] | undefined;
            deny?: string[] | undefined;
        } | "warn" | "off" | [{
            allow?: string[] | undefined;
            deny?: string[] | undefined;
        }] | [{
            allow?: string[] | undefined;
            deny?: string[] | undefined;
        }, "error" | "warn" | "off" | undefined] | undefined;
        "no-missing-pkg-files"?: "error" | "warn" | "off" | {
            bin?: boolean | undefined;
            fields?: string[] | undefined;
        } | [{
            bin?: boolean | undefined;
            fields?: string[] | undefined;
        }] | [{
            bin?: boolean | undefined;
            fields?: string[] | undefined;
        }, "error" | "warn" | "off" | undefined] | undefined;
        "no-missing-entry-point"?: "error" | [undefined] | "warn" | "off" | [undefined, "error" | "warn" | "off" | undefined] | undefined;
        "no-missing-exports"?: "error" | "warn" | "off" | {
            types?: boolean | undefined;
            require?: boolean | undefined;
            import?: boolean | undefined;
            order?: boolean | undefined;
            glob?: boolean | undefined;
        } | [{
            types?: boolean | undefined;
            require?: boolean | undefined;
            import?: boolean | undefined;
            order?: boolean | undefined;
            glob?: boolean | undefined;
        }] | [{
            types?: boolean | undefined;
            require?: boolean | undefined;
            import?: boolean | undefined;
            order?: boolean | undefined;
            glob?: boolean | undefined;
        }, "error" | "warn" | "off" | undefined] | undefined;
    }>>;
}, "strip", z.ZodTypeAny, {
    add?: string | string[] | undefined;
    all?: boolean | undefined;
    bail?: boolean | undefined;
    includeRoot?: boolean | undefined;
    json?: boolean | undefined;
    linger?: boolean | undefined;
    verbose?: boolean | undefined;
    workspace?: string | string[] | undefined;
    pm?: string | string[] | undefined;
    script?: string | string[] | undefined;
    scripts?: string | string[] | undefined;
    loose?: boolean | undefined;
    checks?: boolean | undefined;
    rules?: {
        getEnabledRules: () => Set<"no-banned-files" | "no-missing-entry-point" | "no-missing-exports" | "no-missing-pkg-files">;
        isRuleEnabled: (ruleName: string) => boolean;
        "no-banned-files"?: "error" | {
            allow?: string[] | undefined;
            deny?: string[] | undefined;
        } | "warn" | "off" | [{
            allow?: string[] | undefined;
            deny?: string[] | undefined;
        }] | [{
            allow?: string[] | undefined;
            deny?: string[] | undefined;
        }, "error" | "warn" | "off"] | undefined;
        "no-missing-pkg-files"?: "error" | "warn" | "off" | {
            bin?: boolean | undefined;
            fields?: string[] | undefined;
        } | [{
            bin?: boolean | undefined;
            fields?: string[] | undefined;
        }] | [{
            bin?: boolean | undefined;
            fields?: string[] | undefined;
        }, "error" | "warn" | "off"] | undefined;
        "no-missing-entry-point"?: "error" | [undefined] | "warn" | "off" | [undefined, "error" | "warn" | "off"] | undefined;
        "no-missing-exports"?: "error" | "warn" | "off" | {
            types?: boolean | undefined;
            require?: boolean | undefined;
            import?: boolean | undefined;
            order?: boolean | undefined;
            glob?: boolean | undefined;
        } | [{
            types?: boolean | undefined;
            require?: boolean | undefined;
            import?: boolean | undefined;
            order?: boolean | undefined;
            glob?: boolean | undefined;
        }] | [{
            types?: boolean | undefined;
            require?: boolean | undefined;
            import?: boolean | undefined;
            order?: boolean | undefined;
            glob?: boolean | undefined;
        }, "error" | "warn" | "off"] | undefined;
    } | undefined;
}, {
    add?: string | string[] | undefined;
    all?: boolean | undefined;
    bail?: boolean | undefined;
    includeRoot?: boolean | undefined;
    json?: boolean | undefined;
    linger?: boolean | undefined;
    verbose?: boolean | undefined;
    workspace?: string | string[] | undefined;
    pm?: string | string[] | undefined;
    script?: string | string[] | undefined;
    scripts?: string | string[] | undefined;
    loose?: boolean | undefined;
    checks?: boolean | undefined;
    rules?: {
        "no-banned-files"?: "error" | {
            allow?: string[] | undefined;
            deny?: string[] | undefined;
        } | "warn" | "off" | [{
            allow?: string[] | undefined;
            deny?: string[] | undefined;
        }] | [{
            allow?: string[] | undefined;
            deny?: string[] | undefined;
        }, "error" | "warn" | "off" | undefined] | undefined;
        "no-missing-pkg-files"?: "error" | "warn" | "off" | {
            bin?: boolean | undefined;
            fields?: string[] | undefined;
        } | [{
            bin?: boolean | undefined;
            fields?: string[] | undefined;
        }] | [{
            bin?: boolean | undefined;
            fields?: string[] | undefined;
        }, "error" | "warn" | "off" | undefined] | undefined;
        "no-missing-entry-point"?: "error" | [undefined] | "warn" | "off" | [undefined, "error" | "warn" | "off" | undefined] | undefined;
        "no-missing-exports"?: "error" | "warn" | "off" | {
            types?: boolean | undefined;
            require?: boolean | undefined;
            import?: boolean | undefined;
            order?: boolean | undefined;
            glob?: boolean | undefined;
        } | [{
            types?: boolean | undefined;
            require?: boolean | undefined;
            import?: boolean | undefined;
            order?: boolean | undefined;
            glob?: boolean | undefined;
        }] | [{
            types?: boolean | undefined;
            require?: boolean | undefined;
            import?: boolean | undefined;
            order?: boolean | undefined;
            glob?: boolean | undefined;
        }, "error" | "warn" | "off" | undefined] | undefined;
    } | undefined;
}>;
export type SmokerConfig = z.infer<typeof SmokerConfigSchema>;
/**
 * After normalization, `script` and `scripts` are merged into `scripts` and
 * some other props which can be `string | string[]` become `string[]`
 * @internal
 */
export interface NormalizedSmokerConfig extends SmokerConfig {
    add?: string[];
    workspace?: string[];
    pm?: string[];
    script?: never;
    scripts?: string[];
}
export declare function readConfig(): Promise<NormalizedSmokerConfig>;
//# sourceMappingURL=config.d.ts.map