import { z } from 'zod';
import { RuleSeveritySchema } from './severity';
declare const BaseRuleConfigSchema: z.ZodObject<{
    "no-banned-files": z.ZodOptional<z.ZodUnion<[z.ZodDefault<z.ZodEnum<["off", "warn", "error"]>>, z.ZodObject<{
        allow: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        deny: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    }, "strip", z.ZodTypeAny, {
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    }, {
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    }>, z.ZodTuple<[z.ZodObject<{
        allow: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        deny: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    }, "strip", z.ZodTypeAny, {
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    }, {
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    }>], null>, z.ZodTuple<[z.ZodObject<{
        allow: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        deny: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    }, "strip", z.ZodTypeAny, {
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    }, {
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    }>, z.ZodDefault<z.ZodEnum<["off", "warn", "error"]>>], null>]>>;
    "no-missing-pkg-files": z.ZodOptional<z.ZodUnion<[z.ZodDefault<z.ZodEnum<["off", "warn", "error"]>>, z.ZodObject<{
        bin: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        fields: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    }, "strip", z.ZodTypeAny, {
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    }, {
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    }>, z.ZodTuple<[z.ZodObject<{
        bin: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        fields: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    }, "strip", z.ZodTypeAny, {
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    }, {
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    }>], null>, z.ZodTuple<[z.ZodObject<{
        bin: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        fields: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    }, "strip", z.ZodTypeAny, {
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    }, {
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    }>, z.ZodDefault<z.ZodEnum<["off", "warn", "error"]>>], null>]>>;
    "no-missing-entry-point": z.ZodOptional<z.ZodUnion<[z.ZodDefault<z.ZodEnum<["off", "warn", "error"]>>, z.ZodUndefined, z.ZodTuple<[z.ZodUndefined], null>, z.ZodTuple<[z.ZodUndefined, z.ZodDefault<z.ZodEnum<["off", "warn", "error"]>>], null>]>>;
    "no-missing-exports": z.ZodOptional<z.ZodUnion<[z.ZodDefault<z.ZodEnum<["off", "warn", "error"]>>, z.ZodObject<{
        types: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        require: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        import: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        order: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        glob: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
    }, "strip", z.ZodTypeAny, {
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    }, {
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    }>, z.ZodTuple<[z.ZodObject<{
        types: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        require: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        import: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        order: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        glob: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
    }, "strip", z.ZodTypeAny, {
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    }, {
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    }>], null>, z.ZodTuple<[z.ZodObject<{
        types: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        require: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        import: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        order: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        glob: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
    }, "strip", z.ZodTypeAny, {
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    }, {
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    }>, z.ZodDefault<z.ZodEnum<["off", "warn", "error"]>>], null>]>>;
}, "strip", z.ZodTypeAny, {
    "no-banned-files"?: "error" | {
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    } | "warn" | "off" | [{
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    }] | [{
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    }, "error" | "warn" | "off"] | undefined;
    "no-missing-pkg-files"?: "error" | "warn" | "off" | {
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    } | [{
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    }] | [{
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    }, "error" | "warn" | "off"] | undefined;
    "no-missing-entry-point"?: "error" | [undefined] | "warn" | "off" | [undefined, "error" | "warn" | "off"] | undefined;
    "no-missing-exports"?: "error" | "warn" | "off" | {
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    } | [{
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    }] | [{
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    }, "error" | "warn" | "off"] | undefined;
}, {
    "no-banned-files"?: "error" | {
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    } | "warn" | "off" | [{
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    }] | [{
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    }, "error" | "warn" | "off" | undefined] | undefined;
    "no-missing-pkg-files"?: "error" | "warn" | "off" | {
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    } | [{
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    }] | [{
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    }, "error" | "warn" | "off" | undefined] | undefined;
    "no-missing-entry-point"?: "error" | [undefined] | "warn" | "off" | [undefined, "error" | "warn" | "off" | undefined] | undefined;
    "no-missing-exports"?: "error" | "warn" | "off" | {
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    } | [{
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    }] | [{
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    }, "error" | "warn" | "off" | undefined] | undefined;
}>;
export type RawRuleConfig = z.infer<typeof BaseRuleConfigSchema>;
export declare const RuleConfigSchema: z.ZodEffects<z.ZodObject<{
    "no-banned-files": z.ZodOptional<z.ZodUnion<[z.ZodDefault<z.ZodEnum<["off", "warn", "error"]>>, z.ZodObject<{
        allow: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        deny: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    }, "strip", z.ZodTypeAny, {
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    }, {
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    }>, z.ZodTuple<[z.ZodObject<{
        allow: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        deny: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    }, "strip", z.ZodTypeAny, {
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    }, {
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    }>], null>, z.ZodTuple<[z.ZodObject<{
        allow: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        deny: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    }, "strip", z.ZodTypeAny, {
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    }, {
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    }>, z.ZodDefault<z.ZodEnum<["off", "warn", "error"]>>], null>]>>;
    "no-missing-pkg-files": z.ZodOptional<z.ZodUnion<[z.ZodDefault<z.ZodEnum<["off", "warn", "error"]>>, z.ZodObject<{
        bin: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        fields: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    }, "strip", z.ZodTypeAny, {
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    }, {
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    }>, z.ZodTuple<[z.ZodObject<{
        bin: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        fields: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    }, "strip", z.ZodTypeAny, {
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    }, {
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    }>], null>, z.ZodTuple<[z.ZodObject<{
        bin: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        fields: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    }, "strip", z.ZodTypeAny, {
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    }, {
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    }>, z.ZodDefault<z.ZodEnum<["off", "warn", "error"]>>], null>]>>;
    "no-missing-entry-point": z.ZodOptional<z.ZodUnion<[z.ZodDefault<z.ZodEnum<["off", "warn", "error"]>>, z.ZodUndefined, z.ZodTuple<[z.ZodUndefined], null>, z.ZodTuple<[z.ZodUndefined, z.ZodDefault<z.ZodEnum<["off", "warn", "error"]>>], null>]>>;
    "no-missing-exports": z.ZodOptional<z.ZodUnion<[z.ZodDefault<z.ZodEnum<["off", "warn", "error"]>>, z.ZodObject<{
        types: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        require: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        import: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        order: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        glob: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
    }, "strip", z.ZodTypeAny, {
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    }, {
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    }>, z.ZodTuple<[z.ZodObject<{
        types: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        require: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        import: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        order: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        glob: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
    }, "strip", z.ZodTypeAny, {
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    }, {
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    }>], null>, z.ZodTuple<[z.ZodObject<{
        types: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        require: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        import: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        order: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
        glob: z.ZodOptional<z.ZodDefault<z.ZodBoolean>>;
    }, "strip", z.ZodTypeAny, {
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    }, {
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    }>, z.ZodDefault<z.ZodEnum<["off", "warn", "error"]>>], null>]>>;
}, "strip", z.ZodTypeAny, {
    "no-banned-files"?: "error" | {
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    } | "warn" | "off" | [{
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    }] | [{
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    }, "error" | "warn" | "off"] | undefined;
    "no-missing-pkg-files"?: "error" | "warn" | "off" | {
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    } | [{
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    }] | [{
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    }, "error" | "warn" | "off"] | undefined;
    "no-missing-entry-point"?: "error" | [undefined] | "warn" | "off" | [undefined, "error" | "warn" | "off"] | undefined;
    "no-missing-exports"?: "error" | "warn" | "off" | {
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    } | [{
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    }] | [{
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    }, "error" | "warn" | "off"] | undefined;
}, {
    "no-banned-files"?: "error" | {
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    } | "warn" | "off" | [{
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    }] | [{
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    }, "error" | "warn" | "off" | undefined] | undefined;
    "no-missing-pkg-files"?: "error" | "warn" | "off" | {
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    } | [{
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    }] | [{
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    }, "error" | "warn" | "off" | undefined] | undefined;
    "no-missing-entry-point"?: "error" | [undefined] | "warn" | "off" | [undefined, "error" | "warn" | "off" | undefined] | undefined;
    "no-missing-exports"?: "error" | "warn" | "off" | {
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    } | [{
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    }] | [{
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    }, "error" | "warn" | "off" | undefined] | undefined;
}>, {
    getEnabledRules: () => Set<"no-banned-files" | "no-missing-entry-point" | "no-missing-exports" | "no-missing-pkg-files">;
    isRuleEnabled: (ruleName: string) => boolean;
    "no-banned-files"?: "error" | {
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    } | "warn" | "off" | [{
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    }] | [{
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    }, "error" | "warn" | "off"] | undefined;
    "no-missing-pkg-files"?: "error" | "warn" | "off" | {
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    } | [{
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    }] | [{
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    }, "error" | "warn" | "off"] | undefined;
    "no-missing-entry-point"?: "error" | [undefined] | "warn" | "off" | [undefined, "error" | "warn" | "off"] | undefined;
    "no-missing-exports"?: "error" | "warn" | "off" | {
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    } | [{
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    }] | [{
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    }, "error" | "warn" | "off"] | undefined;
}, {
    "no-banned-files"?: "error" | {
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    } | "warn" | "off" | [{
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    }] | [{
        allow?: string[] | undefined;
        deny?: string[] | undefined;
    }, "error" | "warn" | "off" | undefined] | undefined;
    "no-missing-pkg-files"?: "error" | "warn" | "off" | {
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    } | [{
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    }] | [{
        bin?: boolean | undefined;
        fields?: string[] | undefined;
    }, "error" | "warn" | "off" | undefined] | undefined;
    "no-missing-entry-point"?: "error" | [undefined] | "warn" | "off" | [undefined, "error" | "warn" | "off" | undefined] | undefined;
    "no-missing-exports"?: "error" | "warn" | "off" | {
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    } | [{
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    }] | [{
        types?: boolean | undefined;
        require?: boolean | undefined;
        import?: boolean | undefined;
        order?: boolean | undefined;
        glob?: boolean | undefined;
    }, "error" | "warn" | "off" | undefined] | undefined;
}>;
export type RuleConfig = z.infer<typeof RuleConfigSchema>;
export declare const DEFAULT_RULE_CONFIG: {
    readonly "no-missing-pkg-files": "error" | "warn" | "off";
    readonly "no-banned-files": "error" | "warn" | "off";
    readonly "no-missing-entry-point": "error" | "warn" | "off";
    readonly "no-missing-exports": "error" | "warn" | "off";
};
export type RuleSeverity = z.infer<typeof RuleSeveritySchema>;
export {};
//# sourceMappingURL=rule-config.d.ts.map