"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RuleSeveritySchema = exports.RuleSeverities = void 0;
const zod_1 = require("zod");
exports.RuleSeverities = {
    ERROR: 'error',
    WARN: 'warn',
    OFF: 'off',
};
exports.RuleSeveritySchema = zod_1.z
    .enum([exports.RuleSeverities.OFF, exports.RuleSeverities.WARN, exports.RuleSeverities.ERROR])
    .describe('Severity of a rule. `off` disables the rule, `warn` will warn on violations, and `error` will error on violations.');
//# sourceMappingURL=severity.js.map